Attribute VB_Name = "Vegs"
Option Explicit

'
'  V E G E T A B L E S   M A N A G E M E N T
'

Public counter As Long      ' counts the cycles to change from day to night
Public totvegs As Integer           ' total vegs in sim

' adds vegetables in random positions
Public Sub VegsRepopulate()
  Dim n As node
  Dim r As Integer
  Dim rx As Long
  Dim ry As Long
  Dim t As Integer
  For t = 1 To 10
    If Form1.Active Then
      aggiungirob -1, Random(0, SimOpts.FieldWidth), Random(0, SimOpts.FieldHeight)
      totvegs = totvegs + 1
    End If
  Next t
End Sub

' gives vegs their energy meal
Public Sub feedvegs(totnrg As Long, totv As Integer)
  Dim n As node
  Dim t As Integer
  Dim tok As Integer
  Dim depth As Long
  Dim daymod As Single
  
  counter = counter + 1
  If counter > SimOpts.CycleLength And SimOpts.DayNight Then
    OptionsForm.Daytime = Not OptionsForm.Daytime
    counter = 0
    If OptionsForm.Daytime Then
      MDIForm1.daypic.Visible = True
      MDIForm1.nightpic.Visible = False
    Else
      MDIForm1.daypic.Visible = False
      MDIForm1.nightpic.Visible = True
    End If
  End If
  If OptionsForm.Daytime Then daymod = 1 Else daymod = 0
  
  'If totv <> 0 Then tok = (SimOpts.MaxEnergy - totnrg) / (totv * 100)
    
  Set n = rlist.firstnode
  While Not n Is rlist.last
    t = n.robn
    
    If rob(t).Veg And rob(t).nrg > 0 Then
      If SimOpts.Pondmode Then
        depth = (rob(t).Y / 2000) + 1
        If depth <= 0 Then depth = 1
        tok = (SimOpts.LightIntensity / depth ^ SimOpts.Gradient) * daymod + 1
      End If
      
      If tok < 0 Then tok = 0
      
      'rob(t).nrg = rob(t).nrg + tok * (50 / 100)
      rob(t).nrg = rob(t).nrg + totnrg / 2
      If rob(t).nrg > 32000 Then rob(t).nrg = 32000
      rob(t).body = rob(t).body + (totnrg / 2) / 10
      If rob(t).body > 32000 Then rob(t).body = 32000
      rob(t).Radius = rob(t).body / factor
    End If
    Set n = n.pn
  Wend
End Sub
Public Sub feedveg2(t As Integer) 'gives veg an additional meal based on waste
  With rob(t)
  If .nrg + (.Waste / 2) < 32000 Then
    .nrg = .nrg + (.Waste / 2)
    .Waste = .Waste - (.Waste / 2)
  End If
  End With
End Sub

' kill vegetables which are too distant from any robot
Public Sub KillDistVegs(mdist As Long)
  Dim n As node
  Dim t As Integer
  Dim k As Integer
  Dim mdist2 As Long
  Dim dist2 As Long
  Dim currdist2 As Long
  mdist2 = mdist ^ 2
  Set n = rlist.firstorder
  While Not n Is rlist.last
    t = n.robn
    If rob(t).Veg And rob(t).Exist Then
      Dim nn As node
      currdist2 = 10 ^ 8
      Set nn = rlist.nextorder(n)
      While Abs(nn.xpos - n.xpos) < mdist And Not nn Is rlist.last
        k = nn.robn
        If rob(k).Exist And Not rob(k).Veg Then
          dist2 = (rob(k).x - rob(t).x) ^ 2 + (rob(k).Y - rob(t).Y) ^ 2
          If dist2 < currdist2 Then currdist2 = dist2
        End If
        Set nn = rlist.nextorder(nn)
      Wend
      Set nn = rlist.prevorder(n)
      While Abs(nn.xpos - n.xpos) < mdist And Not nn Is rlist.head
        k = nn.robn
        If Not rob(k).Veg Then
          dist2 = (rob(k).x - rob(t).x) ^ 2 + (rob(k).Y - rob(t).Y) ^ 2
          If dist2 < currdist2 Then currdist2 = dist2
        End If
        Set nn = rlist.prevorder(nn)
      Wend
      If currdist2 > mdist2 Then KillRobot (t)
    End If
    Set n = rlist.nextorder(n)
  Wend
End Sub
